package com.ai.android.handlers;

import com.ai.android.handlers.R;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

public class HelloWorld extends Activity 
{
	public static final String tag="HelloWorld";
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) 
    {
    	//call the parent to attach any system level menus
    	super.onCreateOptionsMenu(menu);
 	   	MenuInflater inflater = getMenuInflater(); //from activity
 	   	inflater.inflate(R.menu.main_menu, menu);
    	return true;
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) 
    {
    	appendMenuItemText(item);
    	if (item.getItemId() == R.id.menu_clear)
    	{
    		this.emptyText();
    		return true;
    	}
    	if (item.getItemId() == R.id.menu_send_broadcast)
    	{
    		this.testSendBroadcast();
    		return true;
    	}
    	if (item.getItemId() == R.id.menu_test_thread)
    	{
    		this.testThread();
    		return true;
    	}
    	
    	if (item.getItemId() == R.id.menu_handler1)
    	{
    		this.testHandler();
    		return true;
    	}
    	this.invokeMultiView(item.getItemId());
    	return true;
    }
    private void invokeMultiView(int mid)
    {
		Intent intent = new Intent(this,MultiViewTestHarnessActivity.class);
		intent.putExtra("com.ai.menuid", mid);
		startActivity(intent);
    }
    
    private TextView getTextView()
    {
        return (TextView)this.findViewById(R.id.text1);
    }
    public void appendText(String abc)
    {
        TextView tv = getTextView(); 
        tv.setText(tv.getText() + "\n" + abc);
    }
    
    private void appendMenuItemText(MenuItem menuItem)
    {
       String title = menuItem.getTitle().toString();
       TextView tv = getTextView(); 
       tv.setText(tv.getText() + "\n" + title);
    }
    private void emptyText()
    {
          TextView tv = getTextView();
          tv.setText("");
    }
    private void testSendBroadcast()
    {
    	//Print out what your running thread id is
    	Utils.logThreadSignature();
    	
    	//Create an intent with an action
    	Intent i = new Intent("com.ai.android.intents.testbc");
    	//load up the intent with a message
    	//you want to broadcast
    	i.putExtra("message", "Hello world");
    	
    	//send out the broadcast
    	//there may be multiple receivers receiving it
    	this.sendBroadcast(i);
    	
    	//Log a message after sending the broadcast
    	//This message should appear first in the log file
    	//before the log messages from the broadcast
    	//because they all run on the same thread
    	Log.d(tag,"after send broadcast from main menu");
    }
    
    private TestHandler1 th = null;
    private void testHandler()
    {
    	if (th == null)
    	{
    		th = new TestHandler1(this);
    		this.appendText("Creating a new handler");
    	}
		this.appendText("Starting to send messages");
		th.sendTestMessages();
    }

    Handler threadHandler = null;
    Thread t = null;
    private void testThread()
    {
    	if (threadHandler == null)
    	{
    		threadHandler = new TestHandler2(this);
        	t = new Thread(new TestRunnable(threadHandler));
    	}
    	if (t.getState() != Thread.State.TERMINATED)
    	{
    		Log.d(tag, "thread is new or alive, but not terminated");
    	}
    	else
    	{
    		Log.d(tag, "thread is likely dead. starting now");
    		//you have to create a new thread.
    		//no way to resurrect a dead thread.
        	t = new Thread(new TestRunnable(threadHandler));
    		t.start();
    	}
    }
	@Override
	protected void onPause() 
	{
		Log.d(tag,"onpause. I may be partially or fully invisible");
		this.appendText("onpause");
		super.onPause();
	}

	@Override
	protected void onStop() {
		Log.d(tag,"onstop. I am fully invisible");
		this.appendText("onstop");
		super.onStop();
	}

	@Override
	protected void onDestroy() {
		Log.d(tag,"ondestroy. about to be removed");
		super.onDestroy();
	}

	@Override
	protected void onRestart() {
		Log.d(tag,"onRestart. UI controls are there.");
		super.onRestart();
	}

	@Override
	protected void onStart() {
		Log.d(tag,"onStart. UI may be partially visible.");
		super.onStart();
	}
	@Override
	protected void onResume() {
		Log.d(tag,"onResume. UI fully visible.");
		super.onResume();
	}
   
}